Projekat_ki401/src/java/ki401/jsf/ZaposlenController.java
package ki401.jsf;

import ki401.entiteti.Zaposlen;
import ki401.jsf.util.JsfUtil;
import ki401.jsf.util.PaginationHelper;
import ki401.ejb.facade.ZaposlenFacade;

import java.io.Serializable;
import java.util.ResourceBundle;
import javax.ejb.EJB;
import javax.inject.Named;
import javax.enterprise.context.SessionScoped;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.FacesConverter;
import javax.faces.model.DataModel;
import javax.faces.model.ListDataModel;
import javax.faces.model.SelectItem;

@Named("zaposlenController")
@SessionScoped
public class ZaposlenController implements Serializable {

    private Zaposlen current;
    private DataModel items = null;
    @EJB
    private ki401.ejb.facade.ZaposlenFacade ejbFacade;
    private PaginationHelper pagination;
    private int selectedItemIndex;

    public ZaposlenController() {
    }

    public Zaposlen getSelected() {
        if (current == null) {
            current = new Zaposlen();
            selectedItemIndex = -1;
        }
        return current;
    }

    private ZaposlenFacade getFacade() {
        return ejbFacade;
    }

    public PaginationHelper getPagination() {
        if (pagination == null) {
            pagination = new PaginationHelper(10) {

                @Override
                public int getItemsCount() {
                    return getFacade().count();
                }

                @Override
                public DataModel createPageDataModel() {
                    return new ListDataModel(getFacade().findRange(new int[]{getPageFirstItem(), getPageFirstItem() + getPageSize()}));
                }
            };
        }
        return pagination;
    }

    public String prepareList() {
        recreateModel();
        return "List";
    }

    public String prepareView() {
        current = (Zaposlen) getItems().getRowData();
        selectedItemIndex = pagination.getPageFirstItem() + getItems().getRowIndex();
        return "View";
    }

    public String prepareCreate() {
        current = new Zaposlen();
        selectedItemIndex = -1;
        return "Create";
    }

    public String create() {
        try {
            getFacade().create(current);
            JsfUtil.addSuccessMessage(ResourceBundle.getBundle("/Bundle").getString("ZaposlenCreated"));
            return prepareCreate();
        } catch (Exception e) {
            JsfUtil.addErrorMessage(e, ResourceBundle.getBundle("/Bundle").getString("PersistenceErrorOccured"));
            return null;
        }
    }

    public String prepareEdit() {
        current = (Zaposlen) getItems().getRowData();
        selectedItemIndex = pagination.getPageFirstItem() + getItems().getRowIndex();
        return "Edit";
    }

    public String update() {
        try {
            getFacade().edit(current);
            JsfUtil.addSuccessMessage(ResourceBundle.getBundle("/Bundle").getString("ZaposlenUpdated"));
            return "View";
        } catch (Exception e) {
            JsfUtil.addErrorMessage(e, ResourceBundle.getBundle("/Bundle").getString("PersistenceErrorOccured"));
            return null;
        }
    }

    public String destroy() {
        current = (Zaposlen) getItems().getRowData();
        selectedItemIndex = pagination.getPageFirstItem() + getItems().getRowIndex();
        performDestroy();
        recreatePagination();
        recreateModel();
        return "List";
    }

    public String destroyAndView() {
        performDestroy();
        recreateModel();
        updateCurrentItem();
        if (selectedItemIndex >= 0) {
            return "View";
        } else {
            // all items were removed - go back to list
            recreateModel();
            return "List";
        }
    }

    private void performDestroy() {
        try {
            getFacade().remove(current);
            JsfUtil.addSuccessMessage(ResourceBundle.getBundle("/Bundle").getString("ZaposlenDeleted"));
        } catch (Exception e) {
            JsfUtil.addErrorMessage(e, ResourceBundle.getBundle("/Bundle").getString("PersistenceErrorOccured"));
        }
    }

    private void updateCurrentItem() {
        int count = getFacade().count();
        if (selectedItemIndex >= count) {
            // selected index cannot be bigger than number of items:
            selectedItemIndex = count - 1;
            // go to previous page if last page disappeared:
            if (pagination.getPageFirstItem() >= count) {
                pagination.previousPage();
            }
        }
        if (selectedItemIndex >= 0) {
            current = getFacade().findRange(new int[]{selectedItemIndex, selectedItemIndex + 1}).get(0);
        }
    }

    public DataModel getItems() {
        if (items == null) {
            items = getPagination().createPageDataModel();
        }
        return items;
    }

    private void recreateModel() {
        items = null;
    }

    private void recreatePagination() {
        pagination = null;
    }

    public String next() {
        getPagination().nextPage();
        recreateModel();
        return "List";
    }

    public String previous() {
        getPagination().previousPage();
        recreateModel();
        return "List";
    }

    public SelectItem[] getItemsAvailableSelectMany() {
        return JsfUtil.getSelectItems(ejbFacade.findAll(), false);
    }

    public SelectItem[] getItemsAvailableSelectOne() {
        return JsfUtil.getSelectItems(ejbFacade.findAll(), true);
    }

    public Zaposlen getZaposlen(java.lang.Integer id) {
        return ejbFacade.find(id);
    }

    @FacesConverter(forClass = Zaposlen.class)
    public static class ZaposlenControllerConverter implements Converter {

        @Override
        public Object getAsObject(FacesContext facesContext, UIComponent component, String value) {
            if (value == null || value.length() == 0) {
                return null;
            }
            ZaposlenController controller = (ZaposlenController) facesContext.getApplication().getELResolver().
                    getValue(facesContext.getELContext(), null, "zaposlenController");
            return controller.getZaposlen(getKey(value));
        }

        java.lang.Integer getKey(String value) {
            java.lang.Integer key;
            key = Integer.valueOf(value);
            return key;
        }

        String getStringKey(java.lang.Integer value) {
            StringBuilder sb = new StringBuilder();
            sb.append(value);
            return sb.toString();
        }

        @Override
        public String getAsString(FacesContext facesContext, UIComponent component, Object object) {
            if (object == null) {
                return null;
            }
            if (object instanceof Zaposlen) {
                Zaposlen o = (Zaposlen) object;
                return getStringKey(o.getKorisnikId());
            } else {
                throw new IllegalArgumentException("object " + object + " is of type " + object.getClass().getName() + "; expected type: " + Zaposlen.class.getName());
            }
        }

    }

}

Projekat_ki401/web/zaposlen/Create.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:composition template="/template.xhtml">
        <ui:define name="title">
            <h:outputText value="#{bundle.CreateZaposlenTitle}"></h:outputText>
        </ui:define>
        <ui:define name="body">
            <h:panelGroup id="messagePanel" layout="block">
                <h:messages errorStyle="color: red" infoStyle="color: green" layout="table"/>
            </h:panelGroup>
            <h:form>
                <h:panelGrid columns="2">
                    <h:outputLabel value="#{bundle.CreateZaposlenLabel_korisnikId}" for="korisnikId" />
                    <h:inputText id="korisnikId" value="#{zaposlenController.selected.korisnikId}" title="#{bundle.CreateZaposlenTitle_korisnikId}" required="true" requiredMessage="#{bundle.CreateZaposlenRequiredMessage_korisnikId}"/>
                    <h:outputLabel value="#{bundle.CreateZaposlenLabel_angazovanOd}" for="angazovanOd" />
                    <h:inputText id="angazovanOd" value="#{zaposlenController.selected.angazovanOd}" title="#{bundle.CreateZaposlenTitle_angazovanOd}" required="true" requiredMessage="#{bundle.CreateZaposlenRequiredMessage_angazovanOd}">
                        <f:convertDateTime pattern="MM/dd/yyyy" />
                    </h:inputText>
                    <h:outputLabel value="#{bundle.CreateZaposlenLabel_angazovanDo}" for="angazovanDo" />
                    <h:inputText id="angazovanDo" value="#{zaposlenController.selected.angazovanDo}" title="#{bundle.CreateZaposlenTitle_angazovanDo}" >
                        <f:convertDateTime pattern="MM/dd/yyyy" />
                    </h:inputText>
                    <h:outputLabel value="#{bundle.CreateZaposlenLabel_brojRacuna}" for="brojRacuna" />
                    <h:inputText id="brojRacuna" value="#{zaposlenController.selected.brojRacuna}" title="#{bundle.CreateZaposlenTitle_brojRacuna}" required="true" requiredMessage="#{bundle.CreateZaposlenRequiredMessage_brojRacuna}"/>
                    <h:outputLabel value="#{bundle.CreateZaposlenLabel_korisnik}" for="korisnik" />
                    <h:selectOneMenu id="korisnik" value="#{zaposlenController.selected.korisnik}" title="#{bundle.CreateZaposlenTitle_korisnik}" required="true" requiredMessage="#{bundle.CreateZaposlenRequiredMessage_korisnik}">
                        <f:selectItems value="#{korisnikController.itemsAvailableSelectOne}"/>
                    </h:selectOneMenu>
                    <h:outputLabel value="#{bundle.CreateZaposlenLabel_pozicijaId}" for="pozicijaId" />
                    <h:selectOneMenu id="pozicijaId" value="#{zaposlenController.selected.pozicijaId}" title="#{bundle.CreateZaposlenTitle_pozicijaId}" required="true" requiredMessage="#{bundle.CreateZaposlenRequiredMessage_pozicijaId}">
                        <f:selectItems value="#{pozicijaController.itemsAvailableSelectOne}"/>
                    </h:selectOneMenu>
                    <h:outputLabel value="#{bundle.CreateZaposlenLabel_zvanjeId}" for="zvanjeId" />
                    <h:selectOneMenu id="zvanjeId" value="#{zaposlenController.selected.zvanjeId}" title="#{bundle.CreateZaposlenTitle_zvanjeId}" required="true" requiredMessage="#{bundle.CreateZaposlenRequiredMessage_zvanjeId}">
                        <f:selectItems value="#{zvanjeController.itemsAvailableSelectOne}"/>
                    </h:selectOneMenu>
                </h:panelGrid>
                <br />
                <h:commandLink action="#{zaposlenController.create}" value="#{bundle.CreateZaposlenSaveLink}" />
                <br />
                <br />
                <h:commandLink action="#{zaposlenController.prepareList}" value="#{bundle.CreateZaposlenShowAllLink}" immediate="true"/>
                <br />
                <br />
                <h:link outcome="/index" value="#{bundle.CreateZaposlenIndexLink}"/>
            </h:form>
        </ui:define>
    </ui:composition>

</html>

Projekat_ki401/web/zaposlen/Edit.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:composition template="/template.xhtml">
        <ui:define name="title">
            <h:outputText value="#{bundle.EditZaposlenTitle}"></h:outputText>
        </ui:define>
        <ui:define name="body">
            <h:panelGroup id="messagePanel" layout="block">
                <h:messages errorStyle="color: red" infoStyle="color: green" layout="table"/>
            </h:panelGroup>
            <h:form>
                <h:panelGrid columns="2">
                    <h:outputLabel value="#{bundle.EditZaposlenLabel_korisnikId}" for="korisnikId" />
                    <h:inputText id="korisnikId" value="#{zaposlenController.selected.korisnikId}" title="#{bundle.EditZaposlenTitle_korisnikId}" required="true" requiredMessage="#{bundle.EditZaposlenRequiredMessage_korisnikId}"/>
                    <h:outputLabel value="#{bundle.EditZaposlenLabel_angazovanOd}" for="angazovanOd" />
                    <h:inputText id="angazovanOd" value="#{zaposlenController.selected.angazovanOd}" title="#{bundle.EditZaposlenTitle_angazovanOd}" required="true" requiredMessage="#{bundle.EditZaposlenRequiredMessage_angazovanOd}">
                        <f:convertDateTime pattern="MM/dd/yyyy" />
                    </h:inputText>
                    <h:outputLabel value="#{bundle.EditZaposlenLabel_angazovanDo}" for="angazovanDo" />
                    <h:inputText id="angazovanDo" value="#{zaposlenController.selected.angazovanDo}" title="#{bundle.EditZaposlenTitle_angazovanDo}" >
                        <f:convertDateTime pattern="MM/dd/yyyy" />
                    </h:inputText>
                    <h:outputLabel value="#{bundle.EditZaposlenLabel_brojRacuna}" for="brojRacuna" />
                    <h:inputText id="brojRacuna" value="#{zaposlenController.selected.brojRacuna}" title="#{bundle.EditZaposlenTitle_brojRacuna}" required="true" requiredMessage="#{bundle.EditZaposlenRequiredMessage_brojRacuna}"/>
                    <h:outputLabel value="#{bundle.EditZaposlenLabel_korisnik}" for="korisnik" />
                    <h:selectOneMenu id="korisnik" value="#{zaposlenController.selected.korisnik}" title="#{bundle.EditZaposlenTitle_korisnik}" required="true" requiredMessage="#{bundle.EditZaposlenRequiredMessage_korisnik}">
                        <f:selectItems value="#{korisnikController.itemsAvailableSelectOne}"/>
                    </h:selectOneMenu>
                    <h:outputLabel value="#{bundle.EditZaposlenLabel_pozicijaId}" for="pozicijaId" />
                    <h:selectOneMenu id="pozicijaId" value="#{zaposlenController.selected.pozicijaId}" title="#{bundle.EditZaposlenTitle_pozicijaId}" required="true" requiredMessage="#{bundle.EditZaposlenRequiredMessage_pozicijaId}">
                        <f:selectItems value="#{pozicijaController.itemsAvailableSelectOne}"/>
                    </h:selectOneMenu>
                    <h:outputLabel value="#{bundle.EditZaposlenLabel_zvanjeId}" for="zvanjeId" />
                    <h:selectOneMenu id="zvanjeId" value="#{zaposlenController.selected.zvanjeId}" title="#{bundle.EditZaposlenTitle_zvanjeId}" required="true" requiredMessage="#{bundle.EditZaposlenRequiredMessage_zvanjeId}">
                        <f:selectItems value="#{zvanjeController.itemsAvailableSelectOne}"/>
                    </h:selectOneMenu>
                </h:panelGrid>
                <h:commandLink action="#{zaposlenController.update}" value="#{bundle.EditZaposlenSaveLink}"/>
                <br />
                <br />
                <h:link outcome="View" value="#{bundle.EditZaposlenViewLink}"/>
                <br />
                <h:commandLink action="#{zaposlenController.prepareList}" value="#{bundle.EditZaposlenShowAllLink}" immediate="true"/>
                <br />
                <br />
                <h:link outcome="/index" value="#{bundle.EditZaposlenIndexLink}" />
            </h:form>
        </ui:define>
    </ui:composition>

</html>

Projekat_ki401/web/zaposlen/List.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:composition template="/template.xhtml">
        <ui:define name="title">
            <h:outputText value="#{bundle.ListZaposlenTitle}"></h:outputText>
        </ui:define>
        <ui:define name="body">
            <h:form styleClass="jsfcrud_list_form">
                <h:panelGroup id="messagePanel" layout="block">
                    <h:messages errorStyle="color: red" infoStyle="color: green" layout="table"/>
                </h:panelGroup>
                <h:outputText escape="false" value="#{bundle.ListZaposlenEmpty}" rendered="#{zaposlenController.items.rowCount == 0}"/>
                <h:panelGroup rendered="#{zaposlenController.items.rowCount > 0}">
                    <h:outputText value="#{zaposlenController.pagination.pageFirstItem + 1}..#{zaposlenController.pagination.pageLastItem + 1}/#{zaposlenController.pagination.itemsCount}"/>&nbsp;
                    <h:commandLink action="#{zaposlenController.previous}" value="#{bundle.Previous} #{zaposlenController.pagination.pageSize}" rendered="#{zaposlenController.pagination.hasPreviousPage}"/>&nbsp;
                    <h:commandLink action="#{zaposlenController.next}" value="#{bundle.Next} #{zaposlenController.pagination.pageSize}" rendered="#{zaposlenController.pagination.hasNextPage}"/>&nbsp;
                    <h:dataTable value="#{zaposlenController.items}" var="item" border="0" cellpadding="2" cellspacing="0" rowClasses="jsfcrud_odd_row,jsfcrud_even_row" rules="all" style="border:solid 1px">
                        <h:column>
                            <f:facet name="header">
                                <h:outputText value="#{bundle.ListZaposlenTitle_korisnikId}"/>
                            </f:facet>
                            <h:outputText value="#{item.korisnikId}"/>
                        </h:column>
                        <h:column>
                            <f:facet name="header">
                                <h:outputText value="#{bundle.ListZaposlenTitle_angazovanOd}"/>
                            </f:facet>
                            <h:outputText value="#{item.angazovanOd}">
                                <f:convertDateTime pattern="MM/dd/yyyy" />
                            </h:outputText>
                        </h:column>
                        <h:column>
                            <f:facet name="header">
                                <h:outputText value="#{bundle.ListZaposlenTitle_angazovanDo}"/>
                            </f:facet>
                            <h:outputText value="#{item.angazovanDo}">
                                <f:convertDateTime pattern="MM/dd/yyyy" />
                            </h:outputText>
                        </h:column>
                        <h:column>
                            <f:facet name="header">
                                <h:outputText value="#{bundle.ListZaposlenTitle_brojRacuna}"/>
                            </f:facet>
                            <h:outputText value="#{item.brojRacuna}"/>
                        </h:column>
                        <h:column>
                            <f:facet name="header">
                                <h:outputText value="#{bundle.ListZaposlenTitle_korisnik}"/>
                            </f:facet>
                            <h:outputText value="#{item.korisnik}"/>
                        </h:column>
                        <h:column>
                            <f:facet name="header">
                                <h:outputText value="#{bundle.ListZaposlenTitle_pozicijaId}"/>
                            </f:facet>
                            <h:outputText value="#{item.pozicijaId}"/>
                        </h:column>
                        <h:column>
                            <f:facet name="header">
                                <h:outputText value="#{bundle.ListZaposlenTitle_zvanjeId}"/>
                            </f:facet>
                            <h:outputText value="#{item.zvanjeId}"/>
                        </h:column>
                        <h:column>
                            <f:facet name="header">
                                <h:outputText value="&nbsp;"/>
                            </f:facet>
                            <h:commandLink action="#{zaposlenController.prepareView}" value="#{bundle.ListZaposlenViewLink}"/>
                            <h:outputText value=" "/>
                            <h:commandLink action="#{zaposlenController.prepareEdit}" value="#{bundle.ListZaposlenEditLink}"/>
                            <h:outputText value=" "/>
                            <h:commandLink action="#{zaposlenController.destroy}" value="#{bundle.ListZaposlenDestroyLink}"/>
                        </h:column>
                    </h:dataTable>
                </h:panelGroup>
                <br />
                <h:commandLink action="#{zaposlenController.prepareCreate}" value="#{bundle.ListZaposlenCreateLink}"/>
                <br />
                <br />
                <h:link outcome="/index" value="#{bundle.ListZaposlenIndexLink}"/>
            </h:form>
        </ui:define>
    </ui:composition>

</html>

Projekat_ki401/web/zaposlen/View.xhtml
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:f="http://xmlns.jcp.org/jsf/core">

    <ui:composition template="/template.xhtml">
        <ui:define name="title">
            <h:outputText value="#{bundle.ViewZaposlenTitle}"></h:outputText>
        </ui:define>
        <ui:define name="body">
            <h:panelGroup id="messagePanel" layout="block">
                <h:messages errorStyle="color: red" infoStyle="color: green" layout="table"/>
            </h:panelGroup>
            <h:form>
                <h:panelGrid columns="2">
                    <h:outputText value="#{bundle.ViewZaposlenLabel_korisnikId}"/>
                    <h:outputText value="#{zaposlenController.selected.korisnikId}" title="#{bundle.ViewZaposlenTitle_korisnikId}"/>
                    <h:outputText value="#{bundle.ViewZaposlenLabel_angazovanOd}"/>
                    <h:outputText value="#{zaposlenController.selected.angazovanOd}" title="#{bundle.ViewZaposlenTitle_angazovanOd}">
                        <f:convertDateTime pattern="MM/dd/yyyy" />
                    </h:outputText>
                    <h:outputText value="#{bundle.ViewZaposlenLabel_angazovanDo}"/>
                    <h:outputText value="#{zaposlenController.selected.angazovanDo}" title="#{bundle.ViewZaposlenTitle_angazovanDo}">
                        <f:convertDateTime pattern="MM/dd/yyyy" />
                    </h:outputText>
                    <h:outputText value="#{bundle.ViewZaposlenLabel_brojRacuna}"/>
                    <h:outputText value="#{zaposlenController.selected.brojRacuna}" title="#{bundle.ViewZaposlenTitle_brojRacuna}"/>
                    <h:outputText value="#{bundle.ViewZaposlenLabel_korisnik}"/>
                    <h:outputText value="#{zaposlenController.selected.korisnik}" title="#{bundle.ViewZaposlenTitle_korisnik}"/>
                    <h:outputText value="#{bundle.ViewZaposlenLabel_pozicijaId}"/>
                    <h:outputText value="#{zaposlenController.selected.pozicijaId}" title="#{bundle.ViewZaposlenTitle_pozicijaId}"/>
                    <h:outputText value="#{bundle.ViewZaposlenLabel_zvanjeId}"/>
                    <h:outputText value="#{zaposlenController.selected.zvanjeId}" title="#{bundle.ViewZaposlenTitle_zvanjeId}"/>
                </h:panelGrid>
                <br />
                <h:commandLink action="#{zaposlenController.destroyAndView}" value="#{bundle.ViewZaposlenDestroyLink}"/>
                <br />
                <br />
                <h:link outcome="Edit" value="#{bundle.ViewZaposlenEditLink}"/>
                <br />
                <h:commandLink action="#{zaposlenController.prepareCreate}" value="#{bundle.ViewZaposlenCreateLink}" />
                <br />
                <h:commandLink action="#{zaposlenController.prepareList}" value="#{bundle.ViewZaposlenShowAllLink}"/>
                <br />
                <br />
                <h:link outcome="/index" value="#{bundle.ViewZaposlenIndexLink}"/>

            </h:form>
        </ui:define>
    </ui:composition>

</html>